<?php
/**
 * Created by PhpStorm.
 * User: jderosa
 * Date: 28/02/20
 * Time: 13.04
 */

namespace FiloBlu\Rma\Block\Order;

use Exception;
use FiloBlu\Rma\Model\Payment\ChangeSizePay;
use Magento\Framework\Registry;
use Magento\Framework\View\Element\Template\Context;
use Magento\Quote\Model\QuoteRepository;

/**
 *
 */
class Totals extends \Magento\Sales\Block\Order\Totals
{
    /**
     * @var QuoteRepository
     */
    protected $quoteRepository;

    /**
     * Totals constructor.
     * @param Context $context
     * @param Registry $registry
     * @param QuoteRepository $quoteRepository
     * @param array $data
     */
    public function __construct(Context         $context,
                                Registry        $registry,
                                QuoteRepository $quoteRepository,
                                array           $data = [])
    {
        parent::__construct($context, $registry, $data);
        $this->quoteRepository = $quoteRepository;
    }

    /**
     * @param null $area
     * @return array
     */
    public function getTotals($area = null)
    {
        try {
            $order = $this->getOrder();

            if ($order->getQuoteId() && $order->getPayment()->getMethod() == ChangeSizePay::PAYMENT_CODE) {
                return $this->_totals;
            }

            $totals = [];
            if ($area === null) {
                $totals = $this->_totals;
            } else {
                $area = (string)$area;
                foreach ($this->_totals as $total) {
                    $totalArea = (string)$total->getArea();
                    if ($totalArea == $area) {
                        $totals[] = $total;
                    }
                }
            }
            return $totals;
        } catch (Exception $exception) {
            $this->_logger->critical($exception->getMessage(), ['exception' => $exception]);
            return $this->_totals;
        }

    }

}
